interface HttpsOptions {
    keyPath: string;
    certPath: string;
}
export declare type CosmosConfig = {
    exportPath: string;
    fixtureFileSuffix: string;
    fixturesDir: string;
    globalImports: string[];
    hostname: null | string;
    https: boolean;
    httpsOptions: null | HttpsOptions;
    port: number;
    publicUrl: string;
    rootDir: string;
    staticPath: null | string;
    userDepsFilePath: string;
    watchDirs: string[];
    [option: string]: unknown;
    ui: {
        [pluginName: string]: {};
    };
};
export declare type CosmosConfigInput = Partial<CosmosConfig>;
export declare function getCurrentDir(): string;
export declare function requireConfigFile(cosmosConfigPath: string): CosmosConfigInput;
export {};
