"use strict";

require("regenerator-runtime/runtime");

require("core-js/features/promise");

require("core-js/features/array/find");

require("core-js/features/array/includes");

var _dom = require("../../../dom");

var _errorOverlay = require("./errorOverlay");

require("./hmrErrorHandler");

mount();

function mount() {
  // Use dynamic import to load updated modules upon hot reloading
  var _require = require('./userDeps'),
      rendererConfig = _require.rendererConfig,
      fixtures = _require.fixtures,
      decorators = _require.decorators;

  (0, _dom.mountDomRenderer)({
    rendererConfig: rendererConfig,
    fixtures: fixtures,
    decorators: decorators,
    onErrorReset: _errorOverlay.dismissErrorOverlay
  });
}

if (module.hot) {
  module.hot.accept('./userDeps', function () {
    // If a previous error has been solved, the error overlay auto-closes nicely.
    // If the error persists, however, the overlay will pop up again on its own
    (0, _errorOverlay.dismissErrorOverlay)();
    mount();
  });
}