"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getFixturePatterns = getFixturePatterns;
exports.getDecoratorPatterns = getDecoratorPatterns;
exports.getIgnorePatterns = getIgnorePatterns;

var _shared = require("../shared");

// NODE: These can be made configurable if a proper need arises
var FIXTURE_PATTERNS = ['**/<fixturesDir>/**/*.{js,jsx,ts,tsx}', '**/*.<fixtureFileSuffix>.{js,jsx,ts,tsx}'];
var DECORATOR_PATTERNS = ['**/cosmos.decorator.{js,jsx,ts,tsx}'];
var IGNORE_PATTERNS = ['**/node_modules/**'];

function getFixturePatterns(fixturesDir, fixtureFileSuffix) {
  return FIXTURE_PATTERNS.map(function (pattern) {
    return (0, _shared.replaceKeys)(pattern, {
      '<fixturesDir>': fixturesDir,
      '<fixtureFileSuffix>': fixtureFileSuffix
    });
  });
}

function getDecoratorPatterns() {
  return DECORATOR_PATTERNS;
}

function getIgnorePatterns() {
  return IGNORE_PATTERNS;
}